Timezone in JavaScript Gantt control

The Gantt uses the current system time zone by default. If it needs to follow some other user-specified time zone, then the timezone property must be used.

Understanding date manipulation in JavaScript

The new Date() in JavaScript returns the exact current date object with complete time and timezone information. For example, it may return a value such as Wed Dec 12, 2018, 05:23:27 GMT+0530 (India Standard Time) which indicates that the current date is December 12, 2018, and the current time is 5.23 AM on browsers following the IST timezone.

Display same time everywhere with no time difference

Setting timezone to UTC for Gantt will display the same time as in the database for all the users in different time zone.

CRUD operations with timezone

CRUD operations can be performed with timezone and the Gantt is rendered based on the timezone specified in the load time. All the editing actions will be done based on the user timezone, but on database save action, we have reversed this conversion to local time and provided data to client-side events for better understanding. Refer to the following code example.

Timezone methods

offset

This method is used to calculate the difference between the passed UTC date and timezone.

Parameters Type Description
Date Date UTC time as date object.
Timezone String Timezone.

Returns number

    // Assume your local timezone as IST/UTC+05:30
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let timeZoneOffset: number = timezone.offset(date,"Europe/Paris");
    console.log(timeZoneOffset); //-60

convert

This method is used to convert the passed date from one timezone to another.

Parameters Type Description
Date Date UTC time as date object.
fromOffset number/string Timezone from which date needs to be converted.
toOffset number/string Timezone to which date needs to be converted.

Returns Date

    // Assume your local timezone as IST/UTC+05:30
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let convertedDate: Date = timezone.convert(date, "Europe/Paris", "Asia/Tokya");
    let convertedDate1: Date = timezone.convert(date, 60, -360);
    console.log(convertedDate); //2018-12-05T08:55:11.000Z
 console.log(convertedDate1); //2018-12-05T16:55:11.000Z

remove

This method is used to remove the time difference between passed UTC date and timezone.

Parameters Type Description
Date Date UTC as date object.
Timezone String Timezone.

Returns Date

    // Assume your local timezone as IST/UTC+05:30
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let convertedDate: Date = timezone.remove(date, "Europe/Paris");
    console.log(convertedDate); //2018-12-05T14:25:11.000Z

Timezone in Vue Gantt Chart Component

18 Nov 201824 minutes to read

The Gantt makes use of the current system time zone by default. If it needs to follow some other user-specific time zone, then the timezone property needs to be used.

Understanding date manipulation in JavaScript

The new Date() in JavaScript returns the exact current date object with complete time and timezone information. For example, it may return value such as Wed Dec 12 2018 05:23:27 GMT+0530 (India Standard Time) which indicates that the current date is December 12, 2018 and the current time is 5.23 AM on browsers following the IST timezone.

Display same time everywhere with no time difference

Setting timezone to UTC for Gantt will display the same time as in the database for all the users in different time zone.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields="taskFields"   :height="height" :includeWeekend="true" :timelineSettings="timelineSettings" :timezone="timezone" :durationUnit="durationUnit" :dateFormat="dateFormat"
        >
        </ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
{
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
    const timelineSettings = {
        timelineUnitSize: 65,
        topTier: {
            unit: "Day",
            format: "MMM dd, yyyy",
        },
        bottomTier: {
            unit: "Hour",
            format: "hh:mm a",
        },
    };
    const dateFormat = "hh:mm a";
    const selectionSettings = {
        mode: 'Both',
    };
    const durationUnit = "Hour";
    const timezone = "UTC";
    provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields="taskFields"   :height="height" :includeWeekend="true" :timelineSettings="timelineSettings" :timezone="timezone" :durationUnit="durationUnit" :dateFormat="dateFormat"
        >
        </ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
       {
            TaskID: 1,
            TaskName: 'Project Initiation',
            StartDate: new Date('04/02/2019'),
            EndDate: new Date('04/21/2019'),
            subtasks: [
                {  TaskID: 2, TaskName: 'Site location', StartDate: new Date('04/02/2019'),Duration: 4, Progress: 50 },
                { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'),Duration: 4, Progress: 50  },
                { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            ]
        },
        {
            TaskID: 5,
            TaskName: 'Project Estimation',
            StartDate: new Date('04/02/2019'),
            EndDate: new Date('04/21/2019'),
            subtasks: [
                { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
            ]
        },
    ],
        height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
             timelineSettings: {
                timelineUnitSize: 65,
                topTier: {
                    unit: "Day",
                    format: "MMM dd, yyyy",
                },
                bottomTier: {
                    unit: "Hour",
                    format: "hh:mm a",
                },
            },
            dateFormat: "hh:mm a",
            selectionSettings: {
                mode: 'Both',
            },
            durationUnit: "Hour",
            timezone: "UTC"
        };
    },
    provide: {
      gantt: [ Selection ]
    }
};
</script>

CRUD operations with timezone

CRUD operations can be performed with timezone, and the gantt is rendered based on the timezone specified in the load time. All the editing actions will be done based on the user timezone, but on database save action, we have reversed this conversion to local time and provided data to client side events for the better understanding. Refer to the following code example.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields="taskFields"   :height="height" :includeWeekend="true" :editSettings="editSettings" :timelineSettings="timelineSettings" :timezone="timezone" :durationUnit="durationUnit" :dateFormat="dateFormat" :actionComplete= "actionComplete"
        >
        </ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection, Edit} from "@syncfusion/ej2-vue-gantt";
const data = [
{
        taskID: 1,
        taskName: 'Project Schedule',
        startDate: new Date('02/04/2019 08:00'),
        endDate: new Date('03/10/2019')
    },
    {
        taskID: 2,
        taskName: 'Planning',
        startDate: new Date('02/04/2019 08:00'),
        endDate: new Date('02/10/2019'),
        parentID: 1
    },
    {
        taskID: 3,
        taskName: 'Plan timeline',
        startDate: new Date('02/04/2019 08:00'),
        endDate: new Date('02/10/2019'),
        duration: 6,
        progress: '60',
        parentID: 2
    },
    {
        taskID: 4,
        taskName: 'Plan budget',
        startDate: new Date('02/04/2019 08:00'),
        endDate: new Date('02/10/2019'),
        duration: 6,
        progress: '90',
        parentID: 2
    },
    {
        taskID: 5,
        taskName: 'Allocate resources',
        startDate: new Date('02/04/2019 08:00'),
        endDate: new Date('02/10/2019'),
        duration: 6,
        progress: '75',
        parentID: 2
    },
    {
        taskID: 6,
        taskName: 'Planning complete',
        startDate: new Date('02/06/2019 08:00'),
        endDate: new Date('02/10/2019'),
        duration: 0,
        predecessor: '3FS,4FS,5FS',
        parentID: 2
    },
    {
        taskID: 7,
        taskName: 'Design',
        startDate: new Date('02/13/2019 08:00'),
        endDate: new Date('02/17/2019 08:00'),
        parentID: 1
    },
    {
        taskID: 8,
        taskName: 'Software Specification',
        startDate: new Date('02/13/2019 08:00'),
        endDate: new Date('02/15/2019'),
        duration: 3,
        progress: '60',
        predecessor: '6FS',
        parentID: 7
    },
    {
        taskID: 9,
        taskName: 'Develop prototype',
        startDate: new Date('02/13/2019 08:00'),
        endDate: new Date('02/15/2019'),
        duration: 3,
        progress: '100',
        predecessor: '6FS',
        parentID: 7
        },
    {
        taskID: 10,
        taskName: 'Get approval from customer',
        startDate: new Date('02/16/2019 08:00'),
        endDate: new Date('02/17/2019 08:00'),
        duration: 2,
        progress: '100',
        predecessor: '9FS',
        parentID: 7
    },
    {
        taskID: 11,
        taskName: 'Design complete',
        startDate: new Date('02/17/2019 08:00'),
        endDate: new Date('02/17/2019 08:00'),
        duration: 0,
        predecessor: '10FS',
        parentID: 7
    }
];
const height = '450px';
const taskFields = {
    id: 'taskID',
    name: 'taskName',
    startDate: 'startDate',
    duration: 'duration',
    progress: 'progress',
    dependency: 'predecessor',
    parentID: 'parentID'
};
const editSettings = {
    allowAdding: true,
    allowEditing: true,
    allowDeleting: true,
    allowTaskbarEditing: true,
    showDeleteConfirmDialog: true
};
const dateFormat = "hh:mm a";
const selectionSettings = {
    mode: 'Both',
};
const timelineSettings = {
    timelineUnitSize: 65,
    topTier: {
        unit: "Day",
        format: "MMM dd, yyyy",
    },
    bottomTier: {
        unit: "Hour",
        format: "hh:mm a",
    },
};
const durationUnit = "Hour";
const timezone = "America/New_York";
const actionComplete = (args) => {
    if (args.action == "TaskbarEditing") {
        console.log(args.data.ganttProperties.endDate);
    }
}
provide('gantt',  [ Selection, Edit]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields="taskFields"   :height="height" :includeWeekend="true" :editSettings="editSettings" :timelineSettings="timelineSettings" :timezone="timezone" :durationUnit="durationUnit" :dateFormat="dateFormat" :actionComplete= "actionComplete"
        >
        </ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection, Edit} from "@syncfusion/ej2-vue-gantt";
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
        {
            taskID: 1,
            taskName: 'Project Schedule',
            startDate: new Date('02/04/2019 08:00'),
            endDate: new Date('03/10/2019')
        },
        {
            taskID: 2,
            taskName: 'Planning',
            startDate: new Date('02/04/2019 08:00'),
            endDate: new Date('02/10/2019'),
            parentID: 1
        },
        {
            taskID: 3,
            taskName: 'Plan timeline',
            startDate: new Date('02/04/2019 08:00'),
            endDate: new Date('02/10/2019'),
            duration: 6,
            progress: '60',
            parentID: 2
        },
        {
            taskID: 4,
            taskName: 'Plan budget',
            startDate: new Date('02/04/2019 08:00'),
            endDate: new Date('02/10/2019'),
            duration: 6,
            progress: '90',
            parentID: 2
        },
        {
            taskID: 5,
            taskName: 'Allocate resources',
            startDate: new Date('02/04/2019 08:00'),
            endDate: new Date('02/10/2019'),
            duration: 6,
            progress: '75',
            parentID: 2
        },
        {
            taskID: 6,
            taskName: 'Planning complete',
            startDate: new Date('02/06/2019 08:00'),
            endDate: new Date('02/10/2019'),
            duration: 0,
            predecessor: '3FS,4FS,5FS',
            parentID: 2
        },
        {
            taskID: 7,
            taskName: 'Design',
            startDate: new Date('02/13/2019 08:00'),
            endDate: new Date('02/17/2019 08:00'),
            parentID: 1
        },
        {
            taskID: 8,
            taskName: 'Software Specification',
            startDate: new Date('02/13/2019 08:00'),
            endDate: new Date('02/15/2019'),
            duration: 3,
            progress: '60',
            predecessor: '6FS',
            parentID: 7
        },
        {
            taskID: 9,
            taskName: 'Develop prototype',
            startDate: new Date('02/13/2019 08:00'),
            endDate: new Date('02/15/2019'),
            duration: 3,
            progress: '100',
            predecessor: '6FS',
            parentID: 7
            },
        {
            taskID: 10,
            taskName: 'Get approval from customer',
            startDate: new Date('02/16/2019 08:00'),
            endDate: new Date('02/17/2019 08:00'),
            duration: 2,
            progress: '100',
            predecessor: '9FS',
            parentID: 7
        },
        {
            taskID: 11,
            taskName: 'Design complete',
            startDate: new Date('02/17/2019 08:00'),
            endDate: new Date('02/17/2019 08:00'),
            duration: 0,
            predecessor: '10FS',
            parentID: 7
        }
    ],
            height: '450px',
            taskFields: {
            id: 'taskID',
            name: 'taskName',
            startDate: 'startDate',
            duration: 'duration',
            progress: 'progress',
            dependency: 'predecessor',
            parentID: 'parentID'
        },
        editSettings: {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            showDeleteConfirmDialog: true
        },
        dateFormat: "hh:mm a",
        selectionSettings: {
            mode: 'Both',
        },
        timelineSettings: {
            timelineUnitSize: 65,
            topTier: {
                unit: "Day",
                format: "MMM dd, yyyy",
            },
            bottomTier: {
                unit: "Hour",
                format: "hh:mm a",
            },
        },
        durationUnit: "Hour",
        timezone: "America/New_York",
        };
    },
    provide: {
        gantt: [ Selection, Edit]
    },
    methods:{
        actionComplete(args) {
            if (args.action == "TaskbarEditing") {
                console.log(args.data.ganttProperties.endDate);
            }
        }}
    };
</script>

Timezone methods

offset

This method is used to calculate the difference between passed UTC date and timezone.

Parameters Type Description
Date Date UTC time as date object.
Timezone String Timezone.

Returns number

    // Assume your local timezone as IST/UTC+05:30
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let timeZoneOffset: number = timezone.offset(date,"Europe/Paris");
    console.log(timeZoneOffset); //-60

convert

This method is used to convert the passed date from one timezone to another timezone.

Parameters Type Description
Date Date UTC time as date object.
fromOffset number/string Timezone from which date need to be converted.
toOffset number/string Timezone to which date need to be converted.

Returns Date

    // Assume your local timezone as IST/UTC+05:30
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let convertedDate: Date = timezone.convert(date, "Europe/Paris", "Asia/Tokya");
    let convertedDate1: Date = timezone.convert(date, 60, -360);
    console.log(convertedDate); //2018-12-05T08:55:11.000Z
    console.log(convertedDate1); //2018-12-05T16:55:11.000Z

remove

This method is used to remove the time difference between passed UTC date and timezone.

Parameters Type Description
Date Date UTC as date object.
Timezone String Timezone.

Returns Date

    // Assume your local timezone as IST/UTC+05:30
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let convertedDate: Date = timezone.remove(date, "Europe/Paris");
    console.log(convertedDate); //2018-12-05T14:25:11.000Z

Timezone in React Gantt Chart Component

18 Nov 201824 minutes to read

The React Gantt Chart component uses the system timezone by default for task scheduling and taskbar rendering, based on JavaScript’s new Date() (e.g., Wed Dec 12 2018 05:23:27 GMT+0530 for IST). To support global teams or specific regions, the timezone property allows setting IANA timezones (e.g., “UTC”, “Asia”) to ensure consistent date display across users. This property function properly when the timeline displays hours. To enable this, set timelineViewMode to ‘Hour’ or configure topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’.

The Timezone class from @syncfusion/ej2-base provides methods (offset, convert, remove) to manipulate task dates, integrating with taskFields.startDate and taskFields.endDate. CRUD operations adjust dates via events like actionBegin and actionComplete.

Configure consistent time display

Set the timezone property to a valid IANA timezone (e.g., “UTC”) to display consistent task dates across all users, aligning taskbars with database times.

The following example sets UTC timezone:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from "@syncfusion/ej2-react-gantt";
import { data } from "./datasource";

function App() {
  let ganttInstance = null;

  const taskSettings = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const timelineSettings = {
    timelineUnitSize: 65,
    topTier: { unit: "Day", format: "MMM dd, yyyy" },
    bottomTier: { unit: "Hour", format: "hh:mm a" }
  };

  const dayWorkingTime = [{ from: 0, to: 24 }];

  return (
    <GanttComponent
      id="ganttDefault"
      height="450px"
      dataSource={data}
      taskFields={taskSettings}
      timelineSettings={timelineSettings}
      dayWorkingTime={dayWorkingTime}
      timezone="UTC"
      durationUnit="Hour"
      dateFormat="hh:mm a"
      includeWeekend={true}
      ref={(g) => (ganttInstance = g)}
    >
      <ColumnsDirective>
        <ColumnDirective field="TaskID" headerText="Task ID" width="100" />
        <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
        <ColumnDirective field="StartDate" headerText="Start Date" width="150" />
        <ColumnDirective field="Duration" headerText="Duration" width="150" />
        <ColumnDirective field="Progress" headerText="Progress" width="150" />
      </ColumnsDirective>

      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection, TaskFieldsModel, TimelineSettingsModel } from "@syncfusion/ej2-react-gantt";
import { data } from "./datasource";

function App() {
  let ganttInstance: GanttComponent = null;

  const taskSettings: TaskFieldsModel = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const timelineSettings: TimelineSettingsModel = {
    timelineUnitSize: 65,
    topTier: { unit: "Day", format: "MMM dd, yyyy" },
    bottomTier: { unit: "Hour", format: "hh:mm a" }
  };
  
  const dayWorkingTime: object = [{ from: 0, to: 24 }];

  return (
    <GanttComponent
      id="ganttDefault"
      height="450px"
      dataSource={data}
      taskFields={taskSettings}
      timelineSettings={timelineSettings}
      dayWorkingTime={dayWorkingTime}
      timezone="UTC"
      durationUnit="Hour"
      dateFormat="hh:mm a"
      includeWeekend={true}
      ref={(g) => (ganttInstance = g)}
    >
      <ColumnsDirective>
        <ColumnDirective field="TaskID" headerText="Task ID" width="100" />
        <ColumnDirective field="TaskName" headerText="Task Name" width="250" />
        <ColumnDirective field="StartDate" headerText="Start Date" width="150" />
        <ColumnDirective field="Duration" headerText="Duration" width="150" />
        <ColumnDirective field="Progress" headerText="Progress" width="150" />
      </ColumnsDirective>

      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

This code ensures taskbars reflect UTC dates, unaffected by local timezones.

Set specific timezone

Set a specific timezone using the timezone property, such as America/New_York (UTC -05:00), to display tasks consistently based on that timezone regardless of the local system’s setting. This ensures a task from 9:00 AM to 10:00 AM in New York time, renders the same for all viewers, avoiding time differences in multi-region projects.

import * as React from "react";
import * as ReactDOM from "react-dom";
import {
  GanttComponent,
  Inject,
  Selection,
  Sort,
  ColumnsDirective,
  ColumnDirective
} from "@syncfusion/ej2-react-gantt";

function App() {

  const data = [
    { TaskID: 1, TaskName: "Project Initiation", StartDate: new Date("2025/08/26 09:00"), EndDate: new Date("2025/08/26 10:00") },
    { TaskID: 2, TaskName: "Define Scope", StartDate: new Date("2025/08/26 10:00"), EndDate: new Date("2025/08/26 12:00"), Duration: 2, parentID: 1 },
    { TaskID: 3, TaskName: "Plan Timeline", StartDate: new Date("2025/08/26 13:00"), EndDate: new Date("2025/08/26 14:00"), Duration: 2, parentID: 1 },
    { TaskID: 4, TaskName: "Resource Allocation", StartDate: new Date("2025/08/26 14:00"), EndDate: new Date("2025/08/26 15:00") },
    { TaskID: 5, TaskName: "Develop Prototype", StartDate: new Date("2025/08/26 15:00"), EndDate: new Date("2025/08/26 16:00"), Duration: 2, parentID: 4 },
    { TaskID: 6, TaskName: "Test Prototype", StartDate: new Date("2025/08/26 16:00"), EndDate: new Date("2025/08/26 17:00"), Duration: 2, parentID: 4 }
    ];

  const taskFields = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    parentID: "parentID"
  };

  return (
    <GanttComponent
      height="450px"
      dataSource={data}
      taskFields={taskFields}
      durationUnit="Hour"
      timezone="America/New_York"
    />
  );
}

ReactDOM.render(<App />, document.getElementById("root"));

Display tasks without timezone

Without a specified timezone, the Gantt Chart component renders tasks according to the local system’s timezone, the default behavior. The new Date() constructor interprets task dates relative to the system’s timezone settings, causing variations in displayed times across different regions. For instance, a task scheduled from 9:00 AM to 10:00 AM UTC, appears as 5:00 AM to 6:00 AM EDT on a system in New York (UTC -04:00, accounting for daylight saving time). This suits localized projects where tasks are managed within a single timezone but may cause scheduling conflicts in distributed teams, as a task’s displayed time shifts depending on the system’s location.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent } from "@syncfusion/ej2-react-gantt";

function App() {

  const data = [
    { TaskID: 1, TaskName: "Project Initiation", StartDate: new Date("2025/08/26 09:00"), EndDate: new Date("2025/08/26 10:00") },
    { TaskID: 2, TaskName: "Define Scope", StartDate: new Date("2025/08/26 10:00"), EndDate: new Date("2025/08/26 12:00"), Duration: 2, parentID: 1 },
    { TaskID: 3, TaskName: "Plan Timeline", StartDate: new Date("2025/08/26 13:00"), EndDate: new Date("2025/08/26 14:00"), Duration: 2, parentID: 1 },
    { TaskID: 4, TaskName: "Resource Allocation", StartDate: new Date("2025/08/26 14:00"), EndDate: new Date("2025/08/26 15:00") },
    { TaskID: 5, TaskName: "Develop Prototype", StartDate: new Date("2025/08/26 15:00"), EndDate: new Date("2025/08/26 16:00"), Duration: 2, parentID: 4 },
    { TaskID: 6, TaskName: "Test Prototype", StartDate: new Date("2025/08/26 16:00"), EndDate: new Date("2025/08/26 17:00"), Duration: 2, parentID: 4 }
  ];

  const taskFields = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    parentID: "parentID"
  };

  return (
    <GanttComponent
      dataSource={data}
      height="450px"
      taskFields={taskFields}
      durationUnit="Hour"
    />
  );
}

ReactDOM.render(<App />, document.getElementById("root"));

Handle CRUD operations with timezone

CRUD operations respect the timezone set at load time, with edits processed in the user’s timezone and converted to the database timezone (e.g., UTC) in client-side events like actionBegin and actionComplete.

The following example handles CRUD with timezone:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Edit, Selection } from "@syncfusion/ej2-react-gantt";
import { data } from "./datasource";

function App() {

  let ganttInstance = null;

  const taskSettings = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const editSettings = {
    allowAdding: true,
    allowEditing: true,
    allowDeleting: true,
    allowTaskbarEditing: true,
    showDeleteConfirmDialog: true
  };

  const timelineSettings = {
    timelineUnitSize: 65,
    topTier: { unit: "Day", format: "MMM dd, yyyy" },
    bottomTier: { unit: "Hour", format: "hh:mm a" }
  };

  const dayWorkingTime = [{ from: 0, to: 24 }];

  function actionComplete(args) {
    if (args.action === "TaskbarEditing") {
      console.log(args.data.ganttProperties.startDate);
    }
  }

  return (
    <GanttComponent
      height="450px"
      dataSource={data}
      taskFields={taskSettings}
      editSettings={editSettings}
      dayWorkingTime={dayWorkingTime}
      timelineSettings={timelineSettings}
      timezone="America/New_York"
      durationUnit="Hour"
      dateFormat="hh:mm a"
      includeWeekend={true}
      actionComplete={actionComplete}
      ref={(g) => (ganttInstance = g)}
    >
      <Inject services={[Edit, Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { GanttComponent, Inject, Edit, Selection, ActionCompleteArgs, TaskFieldsModel, EditSettingsModel, TimelineSettingsModel } from "@syncfusion/ej2-react-gantt";
import { data } from "./datasource";

function App() {

  let ganttInstance = null;

  const taskSettings: TaskFieldsModel = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    duration: "Duration",
    progress: "Progress",
    dependency: "Predecessor",
    parentID: "ParentID"
  };

  const editSettings: EditSettingsModel = {
    allowAdding: true,
    allowEditing: true,
    allowDeleting: true,
    allowTaskbarEditing: true,
    showDeleteConfirmDialog: true
  };

  const timelineSettings: TimelineSettingsModel = {
    timelineUnitSize: 65,
    topTier: { unit: "Day", format: "MMM dd, yyyy" },
    bottomTier: { unit: "Hour", format: "hh:mm a" }
  };

  const dayWorkingTime: object = [{ from: 0, to: 24 }];

  function actionComplete(args: ActionCompleteArgs) {
    if (args.action === "TaskbarEditing") {
      console.log(args.data.ganttProperties.startDate);
    }
  }

  return (
    <GanttComponent
      height="450px"
      dataSource={data}
      taskFields={taskSettings}
      editSettings={editSettings}
      dayWorkingTime={dayWorkingTime}
      timelineSettings={timelineSettings}
      timezone="America/New_York"
      durationUnit="Hour"
      dateFormat="hh:mm a"
      includeWeekend={true}
      actionComplete={actionComplete}
      ref={(g) => (ganttInstance = g)}
    >
      <Inject services={[Edit, Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById("root"));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Use timezone methods

The Timezone class from @syncfusion/ej2-base provides methods to manipulate task dates for display or storage in Gantt.

offset

Calculates the difference (in minutes) between a UTC date and a specified timezone.

Parameter Type Description
Date Date UTC date object
Timezone string IANA timezone (e.g., “Europe/Paris”)

Returns: number

    // Assume your local timezone as IST/UTC+05:30.
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let timeZoneOffset: number = timezone.offset(date,"Europe/Paris");
    console.log(timeZoneOffset); //-60

convert

Converts a date from one timezone to another.

Parameter Type Description
Date Date UTC date object
fromOffset number/string Source timezone or offset (e.g., “Europe/Paris” or 60)
toOffset number/string Target timezone or offset (e.g., “Asia/Tokyo” or -540)

Returns: Date

    // Assume your local timezone as IST/UTC+05:30.
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let convertedDate: Date = timezone.convert(date, "Europe/Paris", "Asia/Tokyo");
    let convertedDate1: Date = timezone.convert(date, 60, -360);
    console.log(convertedDate); //2018-12-05T08:55:11.000Z.
    console.log(convertedDate1); //2018-12-05T16:55:11.000Z.

remove

Removes the timezone offset, returning a UTC-equivalent date.

Parameter Type Description
date Date UTC date object
timezone string IANA timezone (e.g., “Europe/Paris”)

Returns: Date

    // Assume your local timezone as IST/UTC+05:30.
    let timezone: Timezone = new Timezone();
    let date: Date = new Date(2018,11,5,15,25,11);
    let convertedDate: Date = timezone.remove(date, "Europe/Paris");
    console.log(convertedDate); //2018-12-05T14:25:11.000Z.

See also

Timezone in Angular Gantt Chart Component

18 Nov 201824 minutes to read

The Angular Gantt Chart component uses the system timezone by default for task scheduling and taskbar rendering, based on JavaScript’s new Date() (e.g., Wed Dec 12 2018 05:23:27 GMT+0530 for IST). To support global teams or specific regions, the timezone property allows setting IANA timezones (e.g., “UTC”, “Asia”) to ensure consistent date display across users. This property function properly when the timeline displays hours. To enable this, set timelineViewMode to ‘Hour’ or configure topTier.unit as ‘Day’ and bottomTier.unit as ‘Hour’.

The Timezone class from @syncfusion/ej2-base provides methods (offset, convert, remove) to manipulate task dates, integrating with taskFields.startDate and taskFields.endDate. CRUD operations adjust dates via events like actionBegin and actionComplete.

Configure consistent time display

Set the timezone property to a valid IANA timezone (e.g., “UTC”) to display consistent task dates across all users, aligning taskbars with database times.

The following example sets UTC timezone:

import { GanttModule } from '@syncfusion/ej2-angular-gantt'
import { SelectionService } from '@syncfusion/ej2-angular-gantt'
import { Component, ViewEncapsulation, OnInit } from '@angular/core';

@Component({
    imports: [GanttModule],
    providers: [SelectionService],
    standalone: true,
    selector: 'app-root',
    template:
        `<ejs-gantt [dataSource]="data" [taskFields]="taskSettings" [dayWorkingTime]="dayWorkingTime" [timelineSettings]="timelineSettings" timezone="UTC" durationUnit="Hour" dateFormat="hh:mm a" height="450px" [includeWeekend]="true">`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    public data?: object[];
    public taskSettings?: object;
    public timelineSettings?: object;
    public timezoneValue: string = 'UTC';
    public dayWorkingTime?: object[];

    public ngOnInit(): void {
        this.data = [
            { TaskID: 1, TaskName: 'Project Schedule', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('03/10/2019') },
            { TaskID: 2, TaskName: 'Planning', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('02/10/2019'), ParentID: 1 },
            { TaskID: 3, TaskName: 'Plan timeline', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('02/10/2019'), Duration: 6, Progress: '60', ParentID: 2 },
            { TaskID: 4, TaskName: 'Plan budget', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('02/10/2019'), Duration: 6, Progress: '90', ParentID: 2 },
            { TaskID: 5, TaskName: 'Allocate resources', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('02/10/2019'), Duration: 6, Progress: '75', ParentID: 2 },
            { TaskID: 6, TaskName: 'Planning complete', StartDate: new Date('02/06/2019 08:00'), EndDate: new Date('02/10/2019'), Duration: 0, Predecessor: '3FS,4FS,5FS', ParentID: 2 },
            { TaskID: 7, TaskName: 'Design', StartDate: new Date('02/13/2019 08:00'), EndDate: new Date('02/17/2019 08:00'), ParentID: 1, },
            { TaskID: 8, TaskName: 'Software Specification', StartDate: new Date('02/13/2019 08:00'), EndDate: new Date('02/15/2019'), Duration: 3, Progress: '60', Predecessor: '6FS', ParentID: 7, },
            { TaskID: 9, TaskName: 'Develop prototype', StartDate: new Date('02/13/2019 08:00'), EndDate: new Date('02/15/2019'), Duration: 3, Progress: '100', Predecessor: '6FS', ParentID: 7, },
            { TaskID: 10, TaskName: 'Get approval from customer', StartDate: new Date('02/16/2019 08:00'), EndDate: new Date('02/17/2019 08:00'), Duration: 2, Progress: '100', Predecessor: '9FS', ParentID: 7 },
            { TaskID: 11, TaskName: 'Design complete', StartDate: new Date('02/17/2019 08:00'), EndDate: new Date('02/17/2019 08:00'), Duration: 0, Predecessor: '10FS', ParentID: 7 }
        ];
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            parentID: 'ParentID'
        };
        this.timelineSettings = {
            timelineUnitSize: 65,
            topTier: {
                unit: 'Day',
                format: 'MMM dd, yyyy'
            },
            bottomTier: {
                unit: 'Hour',
                format: 'hh:mm a'
            }
        };
        this.dayWorkingTime = [{ from: 0, to: 24 }];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

This code ensures taskbars reflect UTC dates, unaffected by local timezones.

Set specific timezone

Set a specific timezone using the timezone property, such as America/New_York (UTC -05:00), to display tasks consistently based on that timezone regardless of the local system’s setting. This ensures a task from 9:00 AM to 10:00 AM in New York time, renders the same for all viewers, avoiding time differences in multi-region projects.

import { Component } from "@angular/core";
import { GanttModule } from "@syncfusion/ej2-angular-gantt";

@Component({
  selector: "app-root",
  imports: [GanttModule],
  standalone: true,
  template: `<ejs-gantt
    [dataSource]="data"
    height="450px"
    [taskFields]="taskFields"
    durationUnit="Hour"
    timezone="America/New_York"
  ></ejs-gantt>`,
})
export class AppComponent {
  public data: object[] = [
    {
      TaskID: 1,
      TaskName: "Project Initiation",
      StartDate: new Date("2025/08/26 09:00"),
      EndDate: new Date("2025/08/26 10:00"),
    },
    {
      TaskID: 2,
      TaskName: "Define Scope",
      StartDate: new Date("2025/08/26 10:00"),
      EndDate: new Date("2025/08/26 12:00"),
      Duration: 2,
      parentID: 1,
    },
    {
      TaskID: 3,
      TaskName: "Plan Timeline",
      StartDate: new Date("2025/08/26 13:00"),
      EndDate: new Date("2025/08/26 14:00"),
      Duration: 2,
      parentID: 1,
    },
    {
      TaskID: 4,
      TaskName: "Resource Allocation",
      StartDate: new Date("2025/08/26 14:00"),
      EndDate: new Date("2025/08/26 15:00"),
    },
    {
      TaskID: 5,
      TaskName: "Develop Prototype",
      StartDate: new Date("2025/08/26 15:00"),
      EndDate: new Date("2025/08/26 16:00"),
      Duration: 2,
      parentID: 4,
    },
    {
      TaskID: 6,
      TaskName: "Test Prototype",
      StartDate: new Date("2025/08/26 16:00"),
      EndDate: new Date("2025/08/26 17:00"),
      Duration: 2,
      parentID: 4,
    },
  ];
  public taskFields: object = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    parentID: "parentID",
  };
}

Display tasks without timezone

Without a specified timezone, the Gantt Chart component renders tasks according to the local system’s timezone, the default behavior. The new Date() constructor interprets task dates relative to the system’s timezone settings, causing variations in displayed times across different regions. For instance, a task scheduled from 9:00 AM to 10:00 AM UTC, appears as 5:00 AM to 6:00 AM EDT on a system in New York (UTC -04:00, accounting for daylight saving time). This suits localized projects where tasks are managed within a single timezone but may cause scheduling conflicts in distributed teams, as a task’s displayed time shifts depending on the system’s location.

import { Component } from "@angular/core";
import { GanttModule } from "@syncfusion/ej2-angular-gantt";

@Component({
  selector: "app-root",
  imports: [GanttModule],
  standalone: true,
  template: `<ejs-gantt
    [dataSource]="data"
    height="450px"
    [taskFields]="taskFields"
    durationUnit="Hour"
  ></ejs-gantt>`,
})
export class AppComponent {
  public data: object[] = [
    {
      TaskID: 1,
      TaskName: "Project Initiation",
      StartDate: new Date("2025/08/26 09:00"),
      EndDate: new Date("2025/08/26 10:00"),
    },
    {
      TaskID: 2,
      TaskName: "Define Scope",
      StartDate: new Date("2025/08/26 10:00"),
      EndDate: new Date("2025/08/26 12:00"),
      Duration: 2,
      parentID: 1,
    },
    {
      TaskID: 3,
      TaskName: "Plan Timeline",
      StartDate: new Date("2025/08/26 13:00"),
      EndDate: new Date("2025/08/26 14:00"),
      Duration: 2,
      parentID: 1,
    },
    {
      TaskID: 4,
      TaskName: "Resource Allocation",
      StartDate: new Date("2025/08/26 14:00"),
      EndDate: new Date("2025/08/26 15:00"),
    },
    {
      TaskID: 5,
      TaskName: "Develop Prototype",
      StartDate: new Date("2025/08/26 15:00"),
      EndDate: new Date("2025/08/26 16:00"),
      Duration: 2,
      parentID: 4,
    },
    {
      TaskID: 6,
      TaskName: "Test Prototype",
      StartDate: new Date("2025/08/26 16:00"),
      EndDate: new Date("2025/08/26 17:00"),
      Duration: 2,
      parentID: 4,
    },
  ];
  public taskFields: object = {
    id: "TaskID",
    name: "TaskName",
    startDate: "StartDate",
    endDate: "EndDate",
    duration: "Duration",
    parentID: "parentID",
  };
}

Handle CRUD operations with timezone

CRUD operations respect the timezone set at load time, with edits processed in the user’s timezone and converted to the database timezone (e.g., UTC) in client-side events like actionBegin and actionComplete.

The following example handles CRUD with timezone:

import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { GanttModule, EditService, ITaskAddedEventArgs, SelectionService, IGanttData } from '@syncfusion/ej2-angular-gantt'

@Component({
  imports: [GanttModule],
  providers: [EditService, SelectionService],
  standalone: true,
  selector: 'app-root',
  template:
    `<ejs-gantt [dataSource]="data" [editSettings]="editSettings" [taskFields]="taskSettings" [dayWorkingTime]="dayWorkingTime" (actionComplete)="actionComplete($event)" [timelineSettings]="timelineSettings" timezone="America/New_York" durationUnit="Hour" dateFormat="hh:mm a" height="450px" [includeWeekend]="true">`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  public data?: object[];
  public taskSettings?: object;
  public timelineSettings?: object;
  public timezoneValue: string = 'UTC';
  public dayWorkingTime?: object[];
  public editSettings?: object;

  public ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Schedule', StartDate: new Date('02/04/2019 08:00'),
        EndDate: new Date('03/10/2019')
      },
      {
        TaskID: 2, TaskName: 'Planning', StartDate: new Date('02/04/2019 08:00'),
        EndDate: new Date('02/10/2019'), ParentID: 1
      },
      {
        TaskID: 3, TaskName: 'Plan timeline', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('02/10/2019'),
        Duration: 6, Progress: '60', ParentID: 2
      },
      {
        TaskID: 4, TaskName: 'Plan budget', StartDate: new Date('02/04/2019 08:00'),
        EndDate: new Date('02/10/2019'), Duration: 6, Progress: '90', ParentID: 2
      },
      {
        TaskID: 5, TaskName: 'Allocate resources', StartDate: new Date('02/04/2019 08:00'), EndDate: new Date('02/10/2019'),
        Duration: 6, Progress: '75', ParentID: 2
      },
      {
        TaskID: 6, TaskName: 'Planning complete', StartDate: new Date('02/06/2019 08:00'),
        EndDate: new Date('02/10/2019'), Duration: 0, Predecessor: '3FS,4FS,5FS', ParentID: 2
      },
      {
        TaskID: 7, TaskName: 'Design', StartDate: new Date('02/13/2019 08:00'), EndDate: new Date('02/17/2019 08:00'),
        ParentID: 1
      },
      {
        TaskID: 8, TaskName: 'Software Specification', StartDate: new Date('02/13/2019 08:00'), EndDate: new Date('02/15/2019'),
        Duration: 3, Progress: '60', Predecessor: '6FS', ParentID: 7
      },
      {
        TaskID: 9, TaskName: 'Develop prototype', StartDate: new Date('02/13/2019 08:00'), EndDate: new Date('02/15/2019'),
        Duration: 3, Progress: '100', Predecessor: '6FS', ParentID: 7
      },
      {
        TaskID: 10, TaskName: 'Get approval from customer', StartDate: new Date('02/16/2019 08:00'), EndDate: new Date('02/17/2019 08:00'),
        Duration: 2, Progress: '100', Predecessor: '9FS', ParentID: 7
      },
      {
        TaskID: 11, TaskName: 'Design complete', StartDate: new Date('02/17/2019 08:00'), EndDate: new Date('02/17/2019 08:00'),
        Duration: 0, Predecessor: '10FS', ParentID: 7
      }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.editSettings = {
      allowAdding: true,
      allowEditing: true,
      allowDeleting: true,
      allowTaskbarEditing: true,
      showDeleteConfirmDialog: true
    };
    this.timelineSettings = {
      timelineUnitSize: 65,
      topTier: {
        unit: 'Day',
        format: 'MMM dd, yyyy'
      },
      bottomTier: {
        unit: 'Hour',
        format: 'hh:mm a'
      }
    };
    this.dayWorkingTime = [{ from: 0, to: 24 }];
  }

  public actionComplete(args: ITaskAddedEventArgs) {
    if (args.action == "TaskbarEditing") {
      console.log((args.data as any).ganttProperties.startDate);
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Use timezone methods

The Timezone class from @syncfusion/ej2-base provides methods to manipulate task dates for display or storage in Gantt.

offset

Calculates the difference (in minutes) between a UTC date and a specified timezone.

Parameter Type Description
Date Date UTC date object
Timezone string IANA timezone (e.g., “Europe/Paris”)

Returns: number

// Assume your local timezone as IST/UTC+05:30.
let timezone: Timezone = new Timezone();
let date: Date = new Date(2018, 11, 5, 15, 25, 11);
let timeZoneOffset: number = timezone.offset(date, "Europe/Paris");
console.log(timeZoneOffset); //-60

convert

Converts a date from one timezone to another.

Parameter Type Description
Date Date UTC date object
fromOffset number/string Source timezone or offset (e.g., “Europe/Paris” or 60)
toOffset number/string Target timezone or offset (e.g., “Asia/Tokyo” or -540)

Returns: Date

// Assume your local timezone as IST/UTC+05:30.
let timezone: Timezone = new Timezone();
let date: Date = new Date(2018, 11, 5, 15, 25, 11);
let convertedDate: Date = timezone.convert(date, "Europe/Paris", "Asia/Tokyo");
let convertedDate1: Date = timezone.convert(date, 60, -360);
console.log(convertedDate); //2018-12-05T08:55:11.000Z.
console.log(convertedDate1); //2018-12-05T16:55:11.000Z.

remove

Removes the timezone offset, returning a UTC-equivalent date.

Parameter Type Description
date Date UTC date object
timezone string IANA timezone (e.g., “Europe/Paris”)

Returns: Date

// Assume your local timezone as IST/UTC+05:30.
let timezone: Timezone = new Timezone();
let date: Date = new Date(2018, 11, 5, 15, 25, 11);
let convertedDate: Date = timezone.remove(date, "Europe/Paris");
console.log(convertedDate); //2018-12-05T14:25:11.000Z.

See also